-- warfa
-- Bayn TSF3
-- Big thanks to guimchevalier for his script "Pince.lua"
-- 03-09-09
--Automated Load/Unload added by Nibmeister


warfa = {};

function warfa.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function warfa:load(xmlFile)	
		
	local translationPartNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart#index"));
    if translationPartNode ~= nil then
        self.translationPart = {};
        self.translationPart.node = translationPartNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#minTrans"));
        self.translationPart.minTrans = {};
        self.translationPart.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#maxTrans"));
        self.translationPart.maxTrans = {};
        self.translationPart.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#transTime"), 2)*1000;
        self.translationPart.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#touchTransLimit"), 10);
    end;
    
	local rotationNode1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation1#index"));
    if rotationNode1 ~= nil then
        self.rotation1 = {};
        self.rotation1.node = rotationNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#minRot"));
        self.rotation1.minRot = {};
        self.rotation1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#maxRot"));
        self.rotation1.maxRot = {};
        self.rotation1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#rotTime"), 2)*1000;
        self.rotation1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#touchRotLimit"), 10));
    end;
	local rotationNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation2#index"));
    if rotationNode2 ~= nil then
        self.rotation2 = {};
        self.rotation2.node = rotationNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#minRot"));
        self.rotation2.minRot = {};
        self.rotation2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#maxRot"));
        self.rotation2.maxRot = {};
        self.rotation2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#rotTime"), 2)*1000;
        self.rotation2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#touchRotLimit"), 10));
    end;
	local burtNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.burt#index"));
   	 if burtNode ~= nil then
        self.burt = {};
        self.burt.node = burtNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.burt#minRot"));
        self.burt.minRot = {};
        self.burt.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.burt.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.burt.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.burt#maxRot"));
        self.burt.maxRot = {};
        self.burt.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.burt.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.burt.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.burt.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.burt#rotTime"), 2)*1000;
        self.burt.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.burt#touchRotLimit"), 10));
    end;	

      self.numAttachers = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.Attachers#count"), 0);
	self.Attacher = {};
	self.attacherLevel = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Attachers#index"));
	self.ulMode = 1;
	--[[ ulMode is unloading direction, used as index for table below. 
		 Table Values are, per mode as index: [1]str:label [2]boolean:use default code [3] optional table{int:offets  x,y,z}
		 Label and boolean values required, offsets required if 2 is true (if you're using the default unloading code)
		 If 2 is false, any needed values can be filled into values 3+, then use the section marked in the "ObjectDetachwarfa" function below. --]]
	self.ulRef = {{"right",false,{0,0,-5}},{"left",false,{0,0,5}},{"back",false,{0,0,0}},{"custom",true,"This is a custom parameter ;-)"}};	
	for i=1, self.numAttachers do
	 self.Attacher[i] = {};
	 local partnamei = string.format("vehicle.Attachers.objectAttacher".."%d",i);
	 self.Attacher[i].object = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partnamei .. "#index"));
	 setRigidBodyType(self.Attacher[i].coll,"none")
	 self.Attacher[i].attachedObject = nil;
	 self.Attacher[i].objectInRange = nil;
	end;
end;

function warfa:getSaveAttributesAndNodes(nodeIdent)
    for i=1, self.numAttachers do
        ObjectDetachwarfa(self,i)
    end;
    
   return nil, nil;
end;


function warfa:delete()
			for i=1, self.numAttachers do
			ObjectDetachwarfa(self,i)
			end;
end;

function warfa:mouseEvent(posX, posY, isDown, isUp, button)
end;

function warfa:keyEvent(unicode, sym, modifier, isDown)
  
if sym == Input.KEY_KP_3 then
		self.burtMax = isDown;
		end;
	if sym == Input.KEY_KP_6 then
		self.burtMin = isDown;
		end;
if isDown and sym == Input.KEY_9 then
		self.helpPanel = not self.helpPanel;
	end;

   if isDown and sym == Input.KEY_u then
    if self.ulMode == 4 then
      self.ulMode = 0
    end;
    self.ulMode = self.ulMode + 1
  end;

end;

function warfa:update(dt)

	local doRotate = self.rotation1Max or self.rotation1Min 
	if self.rotation1 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation1.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation1.maxRot, self.rotation1.minRot, 3, self.rotation1.rotTime, dt, not self.rotation1Max);
        setRotation(self.rotation1.node, unpack(newRot));
    end;
	
	local doRotate = self.rotation2Max or self.rotation2Min 
	if self.rotation2 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation2.maxRot, self.rotation2.minRot, 3, self.rotation2.rotTime, dt, not self.rotation2Max);
        setRotation(self.rotation2.node, unpack(newRot));
    end;
	local doRotate = self.burtMax or self.burtMin 
	if self.burt ~= nil and doRotate then
        	local x, y, z = getRotation(self.burt.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.burt.maxRot, self.burt.minRot, 3, self.burt.rotTime, dt, not self.burtMax);
        	setRotation(self.burt.node, unpack(newRot));
	end;
			

	if self:getIsActiveForInput() then
		if InputBinding.isPressed(InputBinding.warfaDETACH) then
			-- dcrochage
			for i=1, self.numAttachers do
			ObjectDetachwarfa(self,i)
			end;
		end;

		if InputBinding.isPressed(InputBinding.warfaATTACH) then
			-- dtection ballot
			for i=1, self.numAttachers do
				nearest, index = ObjectInRangewarfa(self,i);
				self.Attacher[i].objectInRange = nearest;
				-- accrochage
				ObjectAttachwarfa(self,i)
			end;

		end;
	end;
end;

function warfa:draw()
	if self.helpPanel then
           g_currentMission:addExtraPrintText("Wcisnij 9: Wylacz info ");
    else
          g_currentMission:addExtraPrintText("Wcisnij 9: Wlacz info");
    end;
	if self.helpPanel then
			renderText(0.72, 0.84, 0.025, "- Warafarma N-218 -");
			renderText(0.72, 0.815, 0.02, "Nacisnij NUM 7: Wypieprz zakladki");	
			renderText(0.72, 0.8, 0.02, "Nacisnij NUM 8: Zdejmij adapter");			
			renderText(0.72, 0.785, 0.02, "Nacisnij NUM 4/5: otworz burte");
			renderText(0.72, 0.77, 0.02, "Nacisnij NUM 1/2: otworz burte");
			renderText(0.72, 0.755, 0.02, "Nacisnij Num 3/6: otworz burte tyl");
			renderText(0.72, 0.74, 0.02, "Nacisnij Num 9: Wypieprz Krate");
			renderText(0.72, 0.725, 0.02, "Nacisnij Num 0: Dodaj Plandeke");
			renderText(0.755, 0.71, 0.02, "by Agromet-Grzegorz056-Bociek");
		end;
end;

function ObjectInRangewarfa(self,k)
	local nearestObject
	local itemNode
	local index 
	local nearestDistance = 15;
	local objectCopy = self.Attacher[k].object;	
	local px, py, pz = getWorldTranslation(objectCopy);
	for i=1, table.getn(g_currentMission.itemsToSave) do
	    itemNode = g_currentMission.itemsToSave[i].node;
	    if getParent(g_currentMission.itemsToSave[i].node) == getRootNode() then
			if getUserAttribute(itemNode, "isStrawbale") or getUserAttribute(itemNode, "isHaybale") then
				local vx, vy, vz = getWorldTranslation(itemNode);
				local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
				if distance < nearestDistance then
					index = i
					nearestObject = itemNode
					nearestDistance = distance
					
				end;
			end;
		end;
	end;
	return nearestObject, index
end;

function ObjectAttachwarfa(self,k)
	if self.Attacher[k].objectInRange ~= nil then
		if self.Attacher[k].attachedObject == nil then
			setRigidBodyType(self.Attacher[k].objectInRange,"none");
			local x,y,z = getWorldRotation(self.Attacher[k].objectInRange);		
			link(self.Attacher[k].object,self.Attacher[k].objectInRange);
			setRotation(self.Attacher[k].objectInRange, 0,0,0);
			setTranslation(self.Attacher[k].objectInRange, 0,0,0)
			self.Attacher[k].attachedObject = self.Attacher[k].objectInRange;
			self.Attacher[k].objectInRange = nil;
		end;
	end;
end;


function ObjectDetachwarfa(self,k)
	if self.Attacher[k].attachedObject ~= nil then			
		if not self.ulRef[self.ulMode][2] then
			local x,y,z = getWorldTranslation(self.Attacher[k].attachedObject)
			local rx,ry,rz = getWorldRotation(self.Attacher[k].attachedObject)
			local nx,ny,nz = getWorldTranslation(self.attacherLevel);
			local tx,ty,tz = unpack(self.ulRef[self.ulMode][3]);
			local x = x + tx
			local y = y + ty
			local z = z + tz
			local tH = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z);
			local relHeight = ny - tH
			local root = getRootNode()
			setRigidBodyType(self.Attacher[k].attachedObject,"Dynamic")
			setTranslation(self.Attacher[k].attachedObject,x,(y - relHeight),z)
			setRotation(self.Attacher[k].attachedObject,rx,ry,rz)
			link(root,self.Attacher[k].attachedObject)
			self.Attacher[k].attachedObject = nil;
		else
			---[[ --Custom unloading chunk.  If you break the game with this and can't fix it, remove a dash from this line to deactivate it.
			print(self.ulRef[self.ulMode][3]);
			-- End of custom unloading chunk. Just leave this line alone.]]
		end;
	end;
end;