-- warfamaboc
-- script by Majster
-- dodatki Grzegorz056
-- <!---@edit: 10.06.2010r.--->

warfamaboc = {};

function warfamaboc.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function warfamaboc:load(xmlFile)
	self.lowerRmp = SpecializationUtil.callSpecializationsFunction("lowerRmp");
	
	self.dustParticleSystems = {};
    local dustParticleSystemCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.dustParticleSystems#count"), 0);
    for i=1, dustParticleSystemCount do
        local namei = string.format("vehicle.dustParticleSystems.part%d", i);
		local nodei = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, namei .. "#index"));
        Utils.loadParticleSystem(xmlFile, self.dustParticleSystems, namei, nodei, false, nil, self.baseDirectory)			
    end;
	
	local workSound = getXMLString(xmlFile, "vehicle.workSound#file");
    if workSound ~= nil and workSound ~= "" then
        workSound = Utils.getFilename(workSound, self.baseDirectory);
        self.workSound = createSample("workSound");
        self.workSoundEnabled = false;
        loadSample(self.workSound, workSound, false);
        self.workSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#pitchOffset"), 1);
        self.workSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#volume"), 1);
    end;
	
	self.literPerSecond = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.literPerSecond#value"), 1);
	
	-----------------------------ADAPTER----------------------------
	self.walek = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.walek#index"));
	self.walek2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.walek2#index"));
	self.walek3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.walek3#index"));
	self.walek4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.walek4#index"));
	self.acmilan = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilan#index"));
   	self.acmilan2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilan2#index"));
    	self.acmilan3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilan3#index"));
	self.acmilan4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilan4#index"));
	self.acmilan5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilan5#index"));
	self.acmilan6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilan6#index"));
	self.acmilan7 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilan7#index"));
	self.acmilanActive = true;
	self.acmilan2Active = true;
	self.acmilan3Active = true;
	self.acmilan4Active = false;
	self.acmilan5Active = false;
	self.acmilan6Active = true;
	self.acmilan7Active = false;
	
	
	self.wom = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wom#index"));
	self.wom2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wom2#index"));
 
    
	local rotationNode1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation1#index"));
    if rotationNode1 ~= nil then
        self.rotation1 = {};
        self.rotation1.node = rotationNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#minRot"));
        self.rotation1.minRot = {};
        self.rotation1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#maxRot"));
        self.rotation1.maxRot = {};
        self.rotation1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#rotTime"), 2)*1000;
        self.rotation1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#touchRotLimit"), 10));
    end;
	local rotationNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation2#index"));
    if rotationNode2 ~= nil then
        self.rotation2 = {};
        self.rotation2.node = rotationNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#minRot"));
        self.rotation2.minRot = {};
        self.rotation2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#maxRot"));
        self.rotation2.maxRot = {};
        self.rotation2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#rotTime"), 2)*1000;
        self.rotation2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#touchRotLimit"), 10));
    end;	

    local numStrawAreas = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.obornikAreas#count"), 0);
    self.strawAreas = {}
    for i=1, numStrawAreas do
        local area = {};
        local areanamei = string.format("vehicle.obornikAreas.obornikArea%d", i);
        area.start = Utils.indexToObject(self.components, getXMLString(xmlFile, areanamei .. "#startIndex"));
        area.width = Utils.indexToObject(self.components, getXMLString(xmlFile, areanamei .. "#widthIndex"));
        area.height = Utils.indexToObject(self.components, getXMLString(xmlFile, areanamei .. "#heightIndex"));
        table.insert(self.strawAreas, area);
    end;
 
end;

function warfamaboc:update(dt)

local doRotate = self.rotation1Max or self.rotation1Min 
	if self.rotation1 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation1.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation1.maxRot, self.rotation1.minRot, 3, self.rotation1.rotTime, dt, not self.rotation1Max);
        setRotation(self.rotation1.node, unpack(newRot));
    end;
	
	local doRotate = self.rotation2Max or self.rotation2Min 
	if self.rotation2 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation2.maxRot, self.rotation2.minRot, 3, self.rotation2.rotTime, dt, not self.rotation2Max);
        setRotation(self.rotation2.node, unpack(newRot));
    end;
	 setVisibility(self.acmilan, self.acmilanActive);
   	 setVisibility(self.acmilan2, self.acmilan2Active);
   	 setVisibility(self.acmilan3, self.acmilan3Active);
	 setVisibility(self.acmilan4, self.acmilan4Active);
	 setVisibility(self.acmilan5, self.acmilan5Active);
 	 setVisibility(self.acmilan6, self.acmilan6Active);
 	 setVisibility(self.acmilan7, self.acmilan7Active);

	if self:getIsActive() then
		
		if self.fillLevel == 0 then
			self.turnOn = false; 
			self:lowerRmp();
			if self.workSoundEnabled then
		        stopSample(self.workSound);
		        self.workSoundEnabled = false;
			end;
		end; 
		
		
		if self.turnOn then
			if not self.backupRmp then
			self.backupRmp = self.attacherVehicle.motor.minRpm;
		end; 			
		if self.attacherVehicle.motor.minRpm >= -600 then
			self.attacherVehicle.motor.minRpm = self.attacherVehicle.motor.minRpm - 10; 
		end; 
			self.gnoj = true;
			local difficultyMultiplier = math.max(3 * (3 - g_currentMission.missionStats.difficulty), 1);
			local deltaLevel = FruitUtil.fruitIndexToDesc[self.currentFillType].literPerQm * difficultyMultiplier * self.literPerSecond;
			self:setFillLevel(self.fillLevel-deltaLevel, self.currentFillType);
			Utils.setEmittingState(self.dustParticleSystems, true)
			for k,cuttingArea in pairs(self.cuttingAreas) do
                local x,y,z = getWorldTranslation(cuttingArea.start);
                local x1,y1,z1 = getWorldTranslation(cuttingArea.width);
                local x2,y2,z2 = getWorldTranslation(cuttingArea.height);
                Utils.updateSprayArea(x, z, x1, z1, x2, z2);
            end;
			if not self.workSoundEnabled and self:getIsActiveForSound() then
	            playSample(self.workSound, 0, self.workSoundVolume, 0);
	            setSamplePitch(self.workSound, self.workSoundPitchOffset);
	            self.workSoundEnabled = true;
	        end;

		elseif not self.turnOn then
			Utils.setEmittingState(self.dustParticleSystems, false)
			self:lowerRmp();
			if self.workSoundEnabled then
		        stopSample(self.workSound);
		        self.workSoundEnabled = false;
			end;
			self.gnoj = false;
		end;
	end;

	if self.gnoj then
            for k, strawArea in pairs(self.strawAreas) do
                local x,y,z = getWorldTranslation(strawArea.start);
                local x1,y1,z1 = getWorldTranslation(strawArea.width);
                local x2,y2,z2 = getWorldTranslation(strawArea.height);
                local old, total = Utils.getFruitWindrowArea(FruitUtil.FRUITTYPE_DUNG, x, z, x1, z1, x2, z2);
                local value = 1+math.floor(old / total + 0.7); -- round, biased to the bigger value
                value = math.min(value, g_currentMission.maxWindrowValue);
                Utils.updateFruitWindrowArea(FruitUtil.FRUITTYPE_DUNG, x, z, x1, z1, x2, z2, value, true);
            end;
        end;	
			
 
	--------------------------ADAPTER-------------------------
	if self.turnOn and self.walek ~= nil then
		rotate(self.walek, dt*0.02, 0, 0);
	end;
	if self.turnOn and self.walek2 ~= nil then
		rotate(self.walek2, dt*0.02, 0,0);
	end;
	if self.turnOn and self.walek3 ~= nil then
		rotate(self.walek3, dt*0.02, 0, 0);
	end;
	if self.turnOn and self.walek4 ~= nil then
		rotate(self.walek4, 0, 0, dt*0.09);
	end;

	if self.turnOn and self.wom ~= nil then
		rotate(self.wom, 0, 0, dt*0.03);
	end;

	if self.turnOn and self.wom2 ~= nil then
		rotate(self.wom2, 0, 0, dt*0.03);
	end;

end;

function warfamaboc:delete()
	Utils.setEmittingState(self.dustParticleSystems, false)
	self:lowerRmp();
	if self.workSoundEnabled then
		stopSample(self.workSound);
		self.workSoundEnabled = false;
	end;
end;

function warfamaboc:mouseEvent(posX, posY, isDown, isUp, button)
end;

function warfamaboc:keyEvent(unicode, sym, modifier, isDown)
	if isDown and sym==Input.KEY_b then
		self.turnOn = not self.turnOn;
	end;
	if isDown and sym == Input.KEY_KP_8 then
		self.acmilanActive = not self.acmilanActive;
		self.acmilan2Active = not self.acmilan2Active;
		self.acmilan3Active = not self.acmilan3Active;
		self.acmilan4Active = not self.acmilan4Active;
	end;
	if isDown and sym == Input.KEY_KP_7 then
		self.acmilan5Active = not self.acmilan5Active;
	end;
	if isDown and sym == Input.KEY_KP_0 then
		self.acmilan7Active = not self.acmilan7Active;
	end;
	if isDown and sym == Input.KEY_KP_9 then
		self.acmilan6Active = not self.acmilan6Active;
	end;
	if sym == Input.KEY_KP_4 then
		self.rotation1Max = isDown;
	end;
	if sym == Input.KEY_KP_5 then
		self.rotation1Min = isDown;
	end;
	if sym == Input.KEY_KP_1 then
		self.rotation2Max = isDown;
	end;
	if sym == Input.KEY_KP_2 then
		self.rotation2Min = isDown;
	end;
end;		

function warfamaboc:draw()
	 		
	if self.turnOn then
       	g_currentMission:addExtraPrintText("Wcisnij B: Wylacz");
    else
       	g_currentMission:addExtraPrintText("Wcisnij B: Wlacz");
    end;
end;

function warfamaboc:onAttach()
end; 	

function warfamaboc:onLeave()

	self.acmilansActive = true;
	self.acmilan2sActive = true;
	self.acmilan3sActive = true;
	self.acmilan4sActive = false;
	self.acmilan5sActive = false;
	self.acmilan6sActive = true;
	self.acmilan6sActive = false;
end;

function warfamaboc:onDetach()
	self.turnOn = false;
	Utils.setEmittingState(self.dustParticleSystems, false)
	if self.workSoundEnabled then
		stopSample(self.workSound);
		self.workSoundEnabled = false;
	end;
	
end

function warfamaboc:lowerRmp()
	if self.backupRmp and self.attacherVehicle then
		if self.attacherVehicle.motor.minRpm <= self.backupRmp then
			self.attacherVehicle.motor.minRpm = self.attacherVehicle.motor.minRpm + 50; 
		else
			self.attacherVehicle.motor.minRpm = self.backupRmp; 
			self.backupRmp = nil; 			
		end; 	
	end; 
end;

